import json
import websocket
import re
import requests
import colorama
from colorama import Fore
import threading
import time
import asyncio


class Client:
    def __init__(self, username, password):
        colorama.init()
        self.sessionID = None
        self.discord_link = "https://discord.gg/tF7j7MswUS"

        self.chars = """
            AabBCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz0123456789 -_`~!@#$%^&*()+=[];:'"|,.<>/?}{\
        """

        self.username = username
        self.password = password

        self.headers = {
            "x-csrftoken": "a",
            "x-requested-with": "XMLHttpRequest",
            "Cookie": "scratchcsrftoken=a;scratchlanguage=en;",
            "referer": "https://scratch.mit.edu",
            "user-agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/91.0.4472.101 Safari/537.36"
        }
        try:

            self.data = json.dumps({
                "username": self.username,
                "password": self.password
            })

            request = requests.post(
                'https://scratch.mit.edu/login/', data=self.data, headers=self.headers)

            self.sessionId = re.search(
                '\"(.*)\"', request.headers['Set-Cookie']).group()

            self.token = request.json()[0]["token"]

            self.headers = {
                "x-requested-with": "XMLHttpRequest",
                "Cookie": "scratchlanguage=en;permissions=%7B%7D;",
                "referer": "https://scratch.mit.edu",
            }

            self.request = requests.get(
                "https://scratch.mit.edu/csrf_token/", headers=self.headers)

            self.csrftoken = re.search(
                "scratchcsrftoken=(.*?);", request.headers["Set-Cookie"]
            ).group(1)

        except AttributeError as error:
            self.error_proxy = error
            self.file = open(__file__, "r", encoding='UTF-8')
            self.line = ""
            self.count = 0
            for i in self.file:
                self.count += 1
                if 'client' in i.lower():
                    self.line = i
                    break

            self.message = f"{Fore.RED}[CloudLink] Invalid Credentials!\n{Fore.YELLOW}  Tip: Double check to make sure your username and password are correct\n {Fore.BLUE} Suggested Line:\n   {Fore.WHITE} Line: {self.count} | {self.line}  {Fore.MAGENTA}Still Having Trouble? Join Our Discord Community: {self.discord_link} {Fore.RESET}"

            print(self.message)

        else:

            self.message = f"{Fore.GREEN}[CloudLink] Logged in as: {username}\n{Fore.RESET}  You will be automatically signed out of your scratch account!"
            print(self.message)

            self.headers = {
                "x-csrftoken": self.csrftoken,
                "X-Token": self.token,
                "x-requested-with": "XMLHttpRequest",
                "Cookie": "scratchcsrftoken=" + self.csrftoken + ";scratchlanguage=en;scratchsessionsid=" + self.sessionId + ";",
                "referer": "",

            }

    def manage(self, pid: int):
        return Manage(pid, self.sessionId, self.username)


class Manage:
    def __init__(self, project_id, session_id, username):
        self.ws = websocket.WebSocket()
        self.project_id, self.session_id, self.username = project_id, session_id, username
        self.proxy_response = None
        self.websocket_connected = True
        self.proxy_calls = 0

        self.stats, self.message, self.counter = None, None, 0

        self.callback_directory = {}
        self.event_dictionary = ['cloud_update', 'connected']
        self.responses = []
        self.cloud_last_values = {}

        self.ws.connect('wss://clouddata.scratch.mit.edu', cookie='scratchsessionsid=' + self.session_id + ';',
                        origin='https://scratch.mit.edu', enable_multithread=True)

        self.proxy_response = self.ws.send(json.dumps({
            'method': 'handshake',
            'user': self.username,
            'project_id': str(self.project_id)
        }) + '\n')


        def call_scratch_api():
            while self.websocket_connected:
                try:
                    self.response = requests.get("https://clouddata.scratch.mit.edu/logs?projectid=" + str(self.project_id) + "&limit=1" + "&offset=0").json()
                    self.response = self.response[0]
                    self.var_name = self.response['name']
                    self.var_value = self.response['value']
                    self.proxy_calls += 1
                    if self.var_name not in self.cloud_last_values:
                        self.cloud_last_values[self.var_name] = self.var_value

                    if self.cloud_last_values[self.var_name] != self.var_value:
                        self.cloud_last_values[self.var_name] = self.var_value
                        if 'cloud_update' in self.callback_directory.keys():
                            threading.Thread(target=asyncio.run, args=(
                            self.callback_directory['cloud_update'](variable=(self.var_name, self.var_value)),)).start()

                    self.responses.append(self.response)
                    time.sleep(0.25)

                    if int(self.proxy_response) == 82:
                        if 'connected' in self.callback_directory.keys() and self.proxy_calls < 2:
                            threading.Thread(target=asyncio.run, args=(
                                 self.callback_directory['connected'](),)).start()
                except:
                    pass

        self.main_loop = threading.Thread(target=call_scratch_api)
        self.main_loop.start()

    async def stop(self):
        self.websocket_connected = False
        self.ws.close()
        self.stats = await self.get_stats()

        if self.counter < 1:
            self.message = f"{Fore.GREEN}[CloudLink] Closed Connection To: {self.stats.title}\n{Fore.RESET}  You will no longer be able to use methods with this project, unless reconnected!"
            print(self.message)
            self.counter += 1
        del self

    def on(self, event):
        def wrapper(function):
            if str(event.lower()) in self.event_dictionary:
                self.callback_directory[event.lower()] = function
            else:
                print('event not found!')
        return wrapper

    async def get_stats(self):
        self.proxy_response = requests.get('https://api.scratch.mit.edu/projects/' + str(self.project_id)).json()
        return Project(self.proxy_response)

    async def set_variable(self, variable, value):
        self.ws.send(json.dumps({
                'method': 'set',
                'name': '☁ ' + variable,
                'value': str(value),
                'user': self.username,
                'project_id': self.project_id
            }) + '\n')


class Project:
    def __init__(self, data):
        for key in data:
            setattr(self, key, data[key])
        self.raw = data
